package com.example.afrishop_v3.repository;

import com.example.afrishop_v3.models.TbCfStationItem;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface TbCfStationItemRepository extends PagingAndSortingRepository<TbCfStationItem,String> {
    Page<TbCfStationItem> findAllByItemCategorytwo(String category, Pageable pageable);
    Page<TbCfStationItem> findAllByItemDescritionId(String description, Pageable pageable);
    Page<TbCfStationItem> findAllByItemLabelContaining(String label, Pageable pageable);
    @Query(value = "select a from #{#entityName} a WHERE a.itemId <> :itemId and (a.itemDescritionId = :descriptionId or a.itemCategorytwo = :categoryTwo  or a.itemCategory = :category )")
    Page<TbCfStationItem> getRecommendItems(@Param("itemId") String itemId,@Param("descriptionId") String descriptionId,@Param("categoryTwo") String categoryTwo,@Param("category") String category, Pageable pageable);
    @Query(value = "select a from #{#entityName} a WHERE a in (SELECT l.item FROM ItemLabel l WHERE l.description IN :tags) and (SELECT count(x.item) FROM ItemLabel x WHERE x.item = a and x.description IN :tags) >= :num ")
    Page<TbCfStationItem> getItemsByImageSearch(@Param("tags") String[] tags,@Param("num") Long num, Pageable pageable);
     @Query(value = "select a from #{#entityName} a order by a.itemTop desc,a.sort asc,a.createTime desc")
    Page<TbCfStationItem> findAllItems(Pageable pageable);
     @Query(value = "select a.* from tb_cf_station_item a where a.item_name LIKE CONCAT('%',?1,'%') or MATCH(a.item_name, a.item_brief) AGAINST(CONCAT(?1,'*') IN BOOLEAN MODE) order by a.item_top desc,a.sort asc,a.create_time desc limit 50",nativeQuery = true)
    List<Object> searchAllItems(@Param("name") String name);
    Page<TbCfStationItem> findAllByItemNameContainingOrItemTagsContaining(String itemName, String itemTags, Pageable pageable);
    Page<TbCfStationItem> findByItemCategory(String itemName, Pageable pageable);
    List<TbCfStationItem> findAllByItemDescritionId(String id);
}
